#include <iostream>
#include <thread>
#include <chrono>
#include <mutex>
#include <dlib/threads.h>

using namespace dlib;
using namespace std;
using namespace std::literals;

int main(int argc, char *argv[])
{
  std::mutex lock;
  dlib::thread_pool tp(4);

  for (int i = 0; i < 10; ++i) {
    auto worker_thread = [i,&lock]() {
      this_thread::sleep_for(3s);
      {
        lock_guard<std::mutex> guard(lock);
        cout << "done " << i << endl;
      }
      return i;
    };
    tp.add_task_by_value(worker_thread);
    {
      lock_guard<std::mutex> guard(lock);
      cout << "finished iteration " << i << endl;
    }
  }
  {
    lock_guard<std::mutex> guard(lock);
    cout << "finished loop" << endl;
  }

  tp.wait_for_all_tasks();
  return 0;
}
